package midp.shopper;

import javax.microedition.lcdui.*;
import java.util.Vector;

public class AddressBookList extends List implements CommandListener {
    SendMessage sender;

    public AddressBookList(SendMessage sender) {
        super(Locale.current.address_book, IMPLICIT);
        this.sender = sender;
        Shopper shopper = Shopper.getInstance();
        Vector addressBook = shopper.addressBook;
        for (int i = addressBook.size(); --i >= 0;) { 
            append(((Address)addressBook.elementAt(i)).name, null);
        }
        setCommandListener(this) ;
        addCommand(Shopper.REMOVE_CMD);
        addCommand(Shopper.SELECT_CMD);
        addCommand(Shopper.BACK_CMD);
        Display.getDisplay(shopper).setCurrent(this);
    }
    
    public void commandAction(Command c, Displayable d)  {
        Shopper shopper = Shopper.getInstance();
        Vector addressBook = shopper.addressBook;
        if (c == Shopper.BACK_CMD) { 
            Display.getDisplay(shopper).setCurrent(sender);
        } else if (c == Shopper.REMOVE_CMD) {   
            int i = getSelectedIndex();
            if (i >= 0) { 
                shopper.removeAddress(addressBook.size()-i-1);
                delete(i);
            }
        } else { 
            int i = getSelectedIndex();
            if (i >= 0) { 
                sender.address = (Address)addressBook.elementAt(addressBook.size()-i-1);
                sender.name.setString(sender.address.name);                
                sender.phone.setString(sender.address.phone);
            }
            Display.getDisplay(shopper).setCurrent(sender);
        }
    }
}
            