package midp.shopper;

public class CommunicatorFactory 
{ 
    public static Communicator[] getCommunicators() 
    { 
        Communicator smsCommunicator = null;
        try { 
            smsCommunicator = (Communicator)Shopper.getClassObject("midp.shopper.SmsCommunicator").newInstance();
        } catch (Exception x) {
            System.out.println("Failed to instantiate class SmsCommunicator");
        }

        Communicator httpCommunicator = null;
        try { 
            httpCommunicator = (Communicator)Shopper.getClassObject("midp.shopper.HttpCommunicator").newInstance();
        } catch (Exception x) {
            System.out.println("Failed to instantiate class HttpCommunicator");
        }

        if (smsCommunicator != null && httpCommunicator != null) { 
            return new Communicator[] {smsCommunicator, httpCommunicator};
        } else if (smsCommunicator != null) { 
            return new Communicator[] {smsCommunicator};
        } else if (httpCommunicator != null) { 
            return new Communicator[] {httpCommunicator};
        } else { 
            return new Communicator[0];
        }
    }
}