package midp.shopper;

public class Convert {
    public static void pack(byte[] arr, int x) { 
        arr[0] = (byte)(x >> 24);
        arr[1] = (byte)(x >> 16);
        arr[2] = (byte)(x >> 8);
        arr[3] = (byte)x;
    }

    public static int unpack(byte[] arr) { 
        return (arr[0] << 24) | ((arr[1] & 0xFF) << 16) | ((arr[2] & 0xFF) << 8) | (arr[3] & 0xFF);
    }

    public static char hexDigit(int d) { 
        d &= 0xF;
        return (char)(d < 10 ? '0' + d : d - 10 + 'A');
    }

    public static int getDigit(char ch) { 
        return ch <= '9' ? ch - '0' : ch + 10 - 'A';
    }

    public static String bytes2Hex(byte[] record) { 
        char[] chars = new char[record.length*2];
        for (int i = 0; i < record.length; i++) { 
            chars[i*2] = hexDigit(record[i] >> 4);
            chars[i*2+1] = hexDigit(record[i]);
        }                
        return new String(chars);
    }
        
    public static byte[] hex2Bytes(String str) { 
        byte[] bytes = new byte[str.length()/2];
        for (int i = 0; i < bytes.length; i++) { 
            bytes[i] = (byte)((getDigit(str.charAt(i*2)) << 4) | getDigit(str.charAt(i*2+1)));
        }                
        return bytes;
    }
        
    public static String bytes2Str(byte[] record, int offs, int length) { 
        char[] chars = new char[length];
        for (int i = 0; i < length; i++) { 
            chars[i] = (char)((record[offs] << 8) | (record[offs+1] & 0xFF));
            offs += 2;
        }                
        return new String(chars);
    }
        

    public static byte[] str2Bytes(String str) { 
        byte[] bytes = new byte[str.length()*2];
        str2Bytes(bytes, 0, str);
        return bytes;
    }

    public static void str2Bytes(byte[] bytes, int offs, String str) { 
        char[] chars = str.toCharArray();
        for (int i = 0; i < chars.length; i++) { 
            bytes[offs + i*2] = (byte)(chars[i] >> 8);
            bytes[offs + i*2+1] = (byte)chars[i];
        }
    }

    public static char bin2HexDigit(int b) { 
        return (char)(b <= 9 ? '0' + b : 'A' + b - 10);
    }

    public static int hexDigit2Bin(char ch) { 
        return ch <= '9' ? ch - '0' : ch - 'A' + 10;
    }

    public static byte[] hex2Bin(String hex) { 
        byte[] bin = new byte[hex.length()/2];
        for (int i = 0; i < bin.length; i++) { 
            bin[i] = (byte)((hexDigit2Bin(hex.charAt(i*2)) << 4) | hexDigit2Bin(hex.charAt(i*2+1)));
        }
        return bin;
    }

    public static String bin2Hex(byte[] bin) { 
        char[] hex = new char[bin.length*2];
        for (int i = 0; i < bin.length; i++) { 
            hex[i*2] = bin2HexDigit((bin[i] >> 4) & 0xF);
            hex[i*2+1] = bin2HexDigit(bin[i] & 0xF);
        }
        return new String(hex);
    }
}
