package midp.shopper;

import java.io.*;
import javax.microedition.lcdui.*;
import java.util.Vector;

public class ImportForm extends List implements CommandListener
{
    byte[] vector;

    public ImportForm(String sender, String text) { 
        super(sender, MULTIPLE);
        vector = Convert.hex2Bin(text);
        Shopper shopper = Shopper.getInstance();
        Vector categories = shopper.getCategories();
        for (int i = 0, nc = categories.size(); i < nc; i++) {
            Vector products = ((Category)categories.elementAt(i)).products;
            for (int j = 0, np = products.size(); j < np; j++) {  
                Product product = (Product)products.elementAt(j);
                int id = shopper.nPredefined + product.recordId;
                if  ((id>>3) < vector.length 
                     && (vector[id>>3] & (1 << (id & 7))) != 0)
                {
                    append(product.name, null);
                }
            }
        }
        boolean[] selected = new boolean[size()];
        for (int i = 0; i < selected.length; i++) { 
            selected[i] = true;
        }
        setSelectedFlags(selected);
        setCommandListener(this);
        addCommand(Shopper.MERGE_CMD);
        addCommand(Shopper.REPLACE_CMD);
        addCommand(Shopper.IGNORE_CMD);
        Display.getDisplay(Shopper.getInstance()).setCurrent(this);
    }
    
    public void commandAction(Command c, Displayable d)  {
        Shopper shopper = Shopper.getInstance();
        boolean[] selected = new boolean[size()];
        getSelectedFlags(selected);
        
        for (int i = 0, n = 0; i < vector.length; i++) { 
            byte b = vector[i];
            for (int j = 0; j < 8; j++) { 
                if ((b & (1 << j)) != 0) { 
                    if (!selected[n++]) { 
                        vector[i] ^= 1 << j;
                    }
                }
            }
        }
        if (c == Shopper.MERGE_CMD) { 
            shopper.merge(vector);
        } else if (c == Shopper.REPLACE_CMD) { 
            shopper.clearData();
            shopper.merge(vector);
        } 
        shopper.getCommunicator().importCompleted();
        Shopper.goBack();
    }
}