package midp.shopper;

import javax.microedition.lcdui.*;

class RenameCategoryBox extends TextBox implements CommandListener 
{
    static final int MAX_CATEGORY_NAME_LENGTH = 32;
    
    private List parent;
    private int  index;

    public RenameCategoryBox(List parent, int index, String oldName) 
    { 
        super(Locale.current.rename, oldName, MAX_CATEGORY_NAME_LENGTH, TextField.ANY); 
        this.parent = parent;
        this.index = index;
        setCommandListener(this);
        addCommand(Shopper.ENTER_CMD);
        addCommand(Shopper.BACK_CMD);
        Display.getDisplay(Shopper.getInstance()).setCurrent(this);
    }
    
    public void commandAction(Command c, Displayable d)  
    {
        Shopper shopper = Shopper.getInstance();
        if (c == Shopper.ENTER_CMD) {
            String newName = getString().trim();
            if (newName.length() != 0) { 
                Category category = (Category)shopper.getCategories().elementAt(index);
                category.name = newName;
                parent.set(index, newName, category.icon);
                shopper.storeCategory(category);
            }
        }
        Display disp = Display.getDisplay(shopper);
        disp.setCurrent(parent);
    }
}
