package midp.shopper;

import javax.microedition.lcdui.*;

public class ResetList extends List implements CommandListener {
    public ResetList() 
    { 
        super(Locale.current.reset, IMPLICIT, Locale.current.resetTypes, null);
        setCommandListener(this) ;
        addCommand(Shopper.SELECT_CMD);
        addCommand(Shopper.BACK_CMD);
    }
    
    public void commandAction(Command c, Displayable d)  {
        if (c == Shopper.BACK_CMD) { 
           Shopper.goBack();
        } else { 
            int i = getSelectedIndex();
            switch (i) { 
            case 0:
                Shopper.getInstance().restoreData();
                break;
            case 1:
                Shopper.getInstance().clearData();
                break;
            case 2:
                Shopper.getInstance().setData();
                break;
            }
            showAlert(Locale.current.resetTypes[i], Locale.current.resetExplanation[i]);
        }
    }
                
                
    static final int ALERT_TIMEOUT = 4000;
    
    private final void showAlert(String title, String text) {
        Alert currentAlert = new Alert(title);
        currentAlert.setTimeout(ALERT_TIMEOUT);
        currentAlert.setString(text);
        currentAlert.setType(AlertType.INFO);
        Display disp = Display.getDisplay(Shopper.getInstance());
        disp.setCurrent(currentAlert, this);
    }
}
 
