package midp.shopper;

import javax.microedition.io.*;
import javax.microedition.lcdui.*;

class SendMessage extends Form implements CommandListener, Runnable
{
    static final int MAX_PHONE_LENGTH = 16;
    static final int MAX_NAME_LENGTH = 16;

    TextField   name;
    TextField   phone;
    Address     address;

    public SendMessage() { 
        super(Locale.current.send);
        Shopper shopper = Shopper.getInstance();
        if (shopper.addressBook.size() != 0) { 
            address = (Address)shopper.addressBook.elementAt(shopper.addressBook.size()-1);
        }
        name = new TextField(Locale.current.username, address != null ? address.name : null, 
                             MAX_NAME_LENGTH, TextField.ANY);
        phone = new TextField(Locale.current.phone, address != null ? address.phone : null, 
                             MAX_PHONE_LENGTH, TextField.PHONENUMBER);
        append(name);
        append(phone);
        
        setCommandListener(this);
        addCommand(Shopper.SEND_CMD);
        addCommand(Shopper.LIST_CMD);
        addCommand(Shopper.BACK_CMD);
    }

    public void commandAction(Command c, Displayable d)  
    {
        Shopper shopper = Shopper.getInstance();
        String newName = name.getString();
        String newPhone = phone.getString();
        
        if (newName.length() != 0 && newPhone.length() != 0 
            && (address == null || !address.name.equals(newName) || !address.phone.equals(newPhone))) 
        {
            shopper.addAddress(newName, newPhone);
        }
        if (c == Shopper.SEND_CMD) { 
            Shopper.goBack();
            new Thread(this).start();
        } else if (c == Shopper.LIST_CMD) { 
            new AddressBookList(this);
        } else { 
            Shopper.goBack();
        }
    } 
    
    public void run() {
        Shopper shopper = Shopper.getInstance();
        Communicator communicator = shopper.getCommunicator();
        if (communicator != null) {
            communicator.send(phone.getString(), shopper.getNeedList());
        }
    }
}