package midp.shopper;

import javax.microedition.lcdui.*;

public class SettingsForm extends Form implements CommandListener { 
    TextField   selfPhone;
    Gauge       pollInterval;
    ChoiceGroup transport;

    static final int MAX_PHONE_LENGTH = 64;

    SettingsForm() { 
        super(Locale.current.settings);        
        Shopper shopper = Shopper.getInstance();
        Settings settings = shopper.settings;
        pollInterval = new Gauge(Locale.current.pollInterval, true, Settings.MAX_POLL_INTERVAL, settings.pollInterval);
        String[] choice = new String[shopper.communicators.length + 1];
        choice[0] = Locale.current.none;
        for (int i = 0; i < shopper.communicators.length; i++) { 
            choice[i+1] = shopper.communicators[i].name();
        }
        transport = new ChoiceGroup(Locale.current.transport, Choice.EXCLUSIVE, choice, null);
        transport.setSelectedIndex(settings.transport+1, true);
        
        selfPhone = new TextField(Locale.current.selfPhone, settings.selfPhone, MAX_PHONE_LENGTH, TextField.PHONENUMBER);

        append(selfPhone);
        append(transport);
        append(pollInterval);
        
        setCommandListener(this);
        addCommand(Shopper.BACK_CMD);
        addCommand(Shopper.SAVE_CMD);
    }
    
    public void commandAction(Command c, Displayable d) 
    {
        if (c == Shopper.SAVE_CMD) {  
            Shopper shopper = Shopper.getInstance();
            Settings settings = shopper.settings;
            settings.selfPhone = selfPhone.getString().trim();
            if (settings.selfPhone.length() == 0) { 
                shopper.error(Locale.current.phoneNotSet);
                return;
            }
            int choice = transport.getSelectedIndex()-1;
            if (choice != settings.transport) { 
                Communicator communicator = shopper.getCommunicator();
                if (communicator != null) { 
                    communicator.stop();
                }
                settings.transport = choice;
                communicator = shopper.getCommunicator();
                if (communicator != null) { 
                    communicator.start();
                }
            }
            if (choice < 0 && shopper.actionList.size() == 5) {
                shopper.actionList.delete(4);
            } else if (choice >= 0 && shopper.actionList.size() < 5) {
                shopper.actionList.append(Locale.current.actionNames[4], null);
            }
            settings.pollInterval = pollInterval.getValue();
            shopper.saveSettings();
        }                
        Shopper.goBack();
    }
}
           

   